diff --git a/lisp/calc/calc-aent.el b/lisp/calc/calc-aent.el
index 131f31afff7..ae04a850f5d 100644
--- a/lisp/calc/calc-aent.el
+++ b/lisp/calc/calc-aent.el
@@ -562,8 +562,8 @@ math-read-preprocess-string
     ;; Cache invalid, recompute.
     (setq math--read-preprocess-re-cache
           (list (rx-to-string
-                 `(or (group (+ (in ,math-read-superscripts)))
-                      (group (+ (in ,math-read-subscripts)))
+                 `(or (or (+ (in ,math-read-superscripts))
+                          (group (+ (in ,math-read-subscripts))))
                       (group (or ,@(mapcar #'car math-read-replacement-list))))
                  t)
                 math-read-replacement-list
@@ -572,13 +572,15 @@ math-read-preprocess-string
   (replace-regexp-in-string
    (nth 0 math--read-preprocess-re-cache)
    (lambda (s)
-     (let ((r (mapconcat (lambda (c)
-                           (cadr (assoc (char-to-string c)
-                                        math-read-replacement-list)))
-                         s)))
-       (cond ((match-beginning 1) (concat "^(" r ")"))
-             ((match-beginning 2) (concat "_(" r ")"))
-             (t r))))
+     (if (match-beginning 2)
+         (cadr (assoc s math-read-replacement-list))
+       (concat (if (match-beginning 1) "_" "^")
+               "("
+               (mapconcat (lambda (c)
+                            (cadr (assoc (char-to-string c)
+                                         math-read-replacement-list)))
+                          s)
+               ")")))
    str t))
 
 ;; The next few variables are local to math-read-exprs (and math-read-expr
